<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\LBExtensions\Templates\Helpers;

use \Sugarcrm\Sugarcrm\custom\PxRoutines\LBExtensions\Templates\Helpers\TemplateEngines\TemplateEngineFactory;

class TemplateProcessor{

    protected $templateBean = null;
    protected $templateEngine = null;
    protected $templateVariables = array();

    protected $templateText = '';

    public function __construct(\PX_FlowchartTemplates $templateBean, $attributes = array()){
        $this->templateBean = $templateBean;
        $this->setTemplateEngine();
        $this->setTemplateVariables($attributes);
    }

    public function process(){
        $formattedText = '';
        try{
            $this->templateEngine->assignLBVariables($this->templateVariables);
            $formattedText = $this->templateEngine->fetchLBTemplate();
        }catch(\Exception $e){
            $GLOBALS['log']->fatal('Error in template: ' . $this->templateBean->name . '.Please check template or contact technical support. (' . $e->getMessage() . ')');
            throw $e;
        }

        return $formattedText;
    }

//    protected function init(){
//        $this->templateEngine->setLBTemplateBean($this->templateBean);
//    }

    protected function setTemplateEngine(){
        if(!empty($this->templateBean->tpl_engine_type)){
            $engineType = $this->templateBean->tpl_engine_type;
            $this->templateEngine = TemplateEngineFactory::getEngine($engineType);
            $this->templateEngine->setLBTemplateBean($this->templateBean);
        }
    }

    public function setTemplateVariables($attributes){
        $this->templateVariables = array();

        if(!is_array($attributes)){
            $attributes = array();
        }
        if(empty($this->templateBean)) return;

        $context = $this->templateBean->getContext();
        $this->templateVariables = $this->mergeTemplateVariables($context, $attributes);
    }

    private function mergeTemplateVariables($defineVariables, $setVariables){
        $mergedVariables = array();
        foreach($defineVariables as $variable){
            $variableName = $variable['name'];
            $variableValue = '';
            if(isset($setVariables[$variableName]))
                $variableValue = $setVariables[$variableName];

            $mergedVariables[$variableName] = array(
                'name' => $variable['name'],
                'label' => $variable['label'],
                'value' => $variableValue
            );
        }
        return $mergedVariables;
    }

//    private function getTemplateVariableLabel($context, $variableName){
//        foreach($context as $item){
//            if($variableName == $item['name']){
//                return $item['label'];
//            }
//        }
//        return '';
//    }

}