<?PHP

require_once('modules/PX_FlowchartTemplates/PX_FlowchartTemplates_sugar.php');

class PX_FlowchartTemplates extends PX_FlowchartTemplates_sugar
{

    const DEFAULT_ENGINE_TYPE = 'base';
    /**
     * This is a depreciated method, please start using __construct() as this method will be removed in a future version
     *
     * @see __construct
     * @depreciated
     */
    function PX_FlowchartTemplates(){
        self::__construct();
    }

    public function __construct(){
        parent::__construct();
    }

    function save($check_notify = false){
        //		$this->html_body = str_replace(array('<', '>'), array('__triangle_bracket_open__', '__triangle_bracket_close__'), $this->html_body);

        if(base64_encode(base64_decode($this->html_body)) !== $this->html_body){
            $this->html_body = base64_encode($this->html_body);
        }
        if(base64_encode(base64_decode($this->context)) !== $this->context){
            $this->context = base64_encode($this->context);
        }

        if(empty($this->tpl_engine_type)){
            $this->tpl_engine_type = self::DEFAULT_ENGINE_TYPE;
        }

        $id = parent::save($check_notify);
        return $id;
    }

    public function populateFromRow(array $row, $convert = false){
        $row = parent::populateFromRow($row, $convert);
        if(!empty($row['html_body']) && base64_encode(base64_decode($row['html_body'])) === $row['html_body']){
//            $row['html_body'] = base64_decode($row['html_body']);
            $row['html_body'] = base64_decode(htmlspecialchars_decode($row['html_body']));
        }
        $row['context'] = $this->getDecodedContext($row['context']);
        return $row;
    }

    function retrieve($id = '-1', $encode = true, $deleted = true){
        $fetched = parent::retrieve($id, $encode, $deleted);
        if(!empty($fetched)) {
            if (!empty($this->html_body) && base64_encode(base64_decode($this->html_body)) === $this->html_body) {
                $this->html_body = base64_decode($this->html_body);
            }
            $this->context = $this->getDecodedContext($this->context);
        }
        return $fetched;
    }

    function fetch($id, array $fields = array(), array $options = array()){
        $fetched = parent::fetch($id, $fields, $options);
        if(!empty($this->html_body) && base64_encode(base64_decode($this->html_body)) === $this->html_body){
            $this->html_body = base64_decode($this->html_body);
        }
        $this->context = $this->getDecodedContext($this->context);
        return $fetched;
    }

    public function getDecodedContext($context){
        if(!empty($context)){
            $base64DecodedContext = base64_decode($context);
            if(!$base64DecodedContext || base64_encode($base64DecodedContext) !== $context){
                $base64DecodedContext = $context;
            }

            if($base64DecodedContext) {
                json_decode($base64DecodedContext, true);
                if (json_last_error() === JSON_ERROR_NONE) {
                    return $base64DecodedContext;
                }
            }

            return 'error';
        }

        return '';
    }

    public function getContext(){
        $context = array();
        if(!empty($this->context) && is_string($this->context)){
            $context = json_decode(htmlspecialchars_decode($this->context), true);
        }
        return json_last_error() == JSON_ERROR_NONE ? $context : array();
    }

    public function getHtmlBody(){
        if(!empty($this->html_body))
            return str_replace(array('%7B', '%7D'), array('{', '}'), $this->html_body);
        return '';
    }

}