({
    extendsFrom: 'EnumField',

    initialize: function() {
        this._super('initialize', arguments);

        this.events = _.extend(this.events, {
            'click [px-context-action=help]:not(.disabled)': 'showHelp'
        });

        this.model.on('sync', this.deactivateHelpButton, this);
        this.model.on("change:tpl_engine_type", this.deactivateHelpButton, this);
    },

    _render: function() {
        this._super('_render', []);

        this.deactivateHelpButton();
        return this;
    },

    deactivateHelpButton: function(){
        var helpText = this.renderHelperBlock(),
            hasHelpText = helpText.length,
            $helpButton = this.$('button[px-context-action=help]');

        if(!$helpButton.length)
            return;

        if(!hasHelpText){
            $helpButton.addClass('disabled');
        }else{
            $helpButton.removeClass('disabled');
        }
    },

    showHelp: function(){
        var helpText = this.renderHelperBlock(),
            alert;

        alert = app.alert.show('lb_template_engine_help', {
            level: 'info',
            title: 'N.B.',
            messages: helpText
        });

        if(alert.$el.find('.alert').length)
            alert.$el.find('.alert').css('width', '550px');
    },

    renderHelperBlock: function(){
        var engineType = this.model.get('tpl_engine_type'),
            helpersList = app.lang.getAppListStrings('px_template_engine_helpers');

        if(!_.isEmpty(helpersList[engineType])){
            return helpersList[engineType];
        }

        return '';
    },
})
